#!/usr/bin/python
'''
  # nsreconfig.py, version 1.0
  # (c) 2002-2008 Jan ONDREJ (SAL) <ondrejj(at)salstar.sk>
  # Licensed under GNU GPLv2+.

  # You can use standard netsaint commands as:
  #   command[...]=...
  # Also you can use varaibles:
  #   var="$1;..."
  # Add to variable:
  #   var+string
  #   - this is replaced by:
  #     var="$var,string" or var="string"
  # Any variable can be user as command:
  #   var param1;param2;...
  # And repetition operator:
  #   @param1;param2;... cmd1,cmd2,...
  #   - this is replaced by:
  #     cmd1 param1;param2;...
  #     cmd2 param1;param2;...
  #     ...
  #   - paramters can be separated by " ", ",", ";"
  # Include file:
  #   <filename
'''

import sys, re

c = []
size_x = 60
size_y = 100
start_x = 25
start_y = 25
pos_x = start_x
pos_y = start_y

def ereg(exp, s, ignore=None):
    global c
    #print exp, s
    r = re.compile(exp).search(s)
    if r:
      c = r.groups()
    return r

def chk(s):
    global cnf, fhost, cmdt, cmds, fx, c, pos_x, pos_y, start_x, start_y
    if ereg('^[<>](.*)$',s):
      # include file
      cnfi = cnf;
      dofile(c[0]);
      cnf = cnfi;
    elif ereg('^[ ]*([a-zA-Z0-9_.]+)=\"?([^"]*)\"?$', s):
      # variable assignment
      cmdt[c[0]] = c[1]
      cmds = "%s|%s" % (cmds, c[0])
    elif s.startswith('moveto '):
      pos_x = start_x + float(s.split(' ', 2)[1])*size_x
      pos_y = start_y + float(s.split(' ', 2)[2])*size_y
    elif s=='startx':
      start_x = pos_x
    elif s.startswith('startx '):
      start_x = int(s.split(' ', 1)[1])
    elif s=='nextrow':
      pos_y += size_y
      pos_x = start_x
    elif s.startswith('nextrow '):
      pos_y += float(s.split(' ', 1)[1])*size_y
      pos_x = start_x
    elif s=='empty':
      pos_x += size_x
    elif s.startswith('empty '):
      pos_x += float(s.split(' ', 1)[1])*size_x
    elif s.startswith('hostextinfo ') and s.count(';')<3:
      chk(s+';%d,%d' % (pos_x, pos_y))
      pos_x += size_x
    elif ereg("^[ ]*([a-zA-Z0-9_.]+)\+(.*)$", s):
      if cmdt.has_key(c[0]):
        cmdt[c[0]] = cmdt[c[0]]+","+c[1]
      else:
        cmdt[c[0]] = c[1]
    elif ereg("^[ ]*(%s)[ \t]*[( ](.*)\)?$" % cmds, s):
      mcmd = cmdt[c[0]]
      margs = c[1].split(";")
      for i in range(1,10):
        if len(margs)>=i:
          mcmd = re.compile("\\$%d" % i).sub(margs[i-1], mcmd)
      for key, value in cmdt.items():
        mcmd = re.compile("\\$%s([^a-zA-Z0-9_]|$)" % key
                          ).sub(value+"\\1", mcmd)
      fhost.write(mcmd+"\n")
    elif ereg("^[ ]*@([-a-zA-Z0-9_;.]*) (.*)$", s):
      ca = re.split("[ ,;]", c[1])
      c0 = c[0]
      for value in ca:
        chk("%s %s" % (value, c0))
    elif ereg("^[ ]*[a-zA-Z0-9_.]*\[", s):
      #print s
      fhost.write(s+"\n")
    elif ereg("^define [a-zA-Z0-9_.]+[ \t]*\{", s):
      #print s
      fhost.write(s+"\n")
    elif s!="":
      print "# Illegal command: '%s'" % s;

def dofile(f):
    global cnf, cmdt, cmds, fhost;
    cnf = open(f, "r")
    s = ""
    while True:
        line = cnf.readline()
        if not line: break
        s += re.compile("#.*$").sub("", line.rstrip()) + "\n";
        if ((s.count('"')%2)==0) and (s.count('{')==s.count('}')):
            #break
            chk(s.rstrip())
            s = ""
    cnf.close()

fhost=open(sys.argv[2], "w")
cmdt = dict(echo="$1", _="\n")
cmds = "echo"
dofile(sys.argv[1])
fhost.close()
